Attribute VB_Name = "Services"
Option Explicit

Public SVC_CancelServiceOperation As Boolean
Public SVC_ServiceControlFail As Boolean
Public SVC_ErrorCode As Long
Public SVC_ErrorMessage As String
Public SVC_ErrorDetails As String
Public SVC_ProgressBar As PictureBox
Public SVC_ProgressFrom As Single
Public SVC_ProgressTo As Single

Private Enum WINAPI_ERRORS
  ERROR_SUCCESS = 0&
  NO_ERROR = 0& 'dderror
  ERROR_INVALID_FUNCTION = 1& 'dderror
  ERROR_FILE_NOT_FOUND = 2&
  ERROR_PATH_NOT_FOUND = 3&
  ERROR_TOO_MANY_OPEN_FILES = 4&
  ERROR_ACCESS_DENIED = 5&
  ERROR_INVALID_HANDLE = 6&
  ERROR_ARENA_TRASHED = 7&
  ERROR_NOT_ENOUGH_MEMORY = 8& 'dderror
  ERROR_INVALID_BLOCK = 9&
  ERROR_BAD_ENVIRONMENT = 10&
  ERROR_BAD_FORMAT = 11&
  ERROR_INVALID_ACCESS = 12&
  ERROR_INVALID_DATA = 13&
  ERROR_OUTOFMEMORY = 14&
  ERROR_INVALID_DRIVE = 15&
  ERROR_CURRENT_DIRECTORY = 16&
  ERROR_NOT_SAME_DEVICE = 17&
  ERROR_NO_MORE_FILES = 18&
  ERROR_WRITE_PROTECT = 19&
  ERROR_BAD_UNIT = 20&
  ERROR_NOT_READY = 21&
  ERROR_BAD_COMMAND = 22&
  ERROR_CRC = 23&
  ERROR_BAD_LENGTH = 24&
  ERROR_SEEK = 25&
  ERROR_NOT_DOS_DISK = 26&
  ERROR_SECTOR_NOT_FOUND = 27&
  ERROR_OUT_OF_PAPER = 28&
  ERROR_WRITE_FAULT = 29&
  ERROR_READ_FAULT = 30&
  ERROR_GEN_FAILURE = 31&
  ERROR_SHARING_VIOLATION = 32&
  ERROR_LOCK_VIOLATION = 33&
  ERROR_WRONG_DISK = 34&
  ERROR_SHARING_BUFFER_EXCEEDED = 36&
  ERROR_HANDLE_EOF = 38&
  ERROR_HANDLE_DISK_FULL = 39&
  ERROR_NOT_SUPPORTED = 50&
  ERROR_REM_NOT_LIST = 51&
  ERROR_DUP_NAME = 52&
  ERROR_BAD_NETPATH = 53&
  ERROR_NETWORK_BUSY = 54&
  ERROR_DEV_NOT_EXIST = 55& 'dderror
  ERROR_TOO_MANY_CMDS = 56&
  ERROR_ADAP_HDW_ERR = 57&
  ERROR_BAD_NET_RESP = 58&
  ERROR_UNEXP_NET_ERR = 59&
  ERROR_BAD_REM_ADAP = 60&
  ERROR_PRINTQ_FULL = 61&
  ERROR_NO_SPOOL_SPACE = 62&
  ERROR_PRINT_CANCELLED = 63&
  ERROR_NETNAME_DELETED = 64&
  ERROR_NETWORK_ACCESS_DENIED = 65&
  ERROR_BAD_DEV_TYPE = 66&
  ERROR_BAD_NET_NAME = 67&
  ERROR_TOO_MANY_NAMES = 68&
  ERROR_TOO_MANY_SESS = 69&
  ERROR_SHARING_PAUSED = 70&
  ERROR_REQ_NOT_ACCEP = 71&
  ERROR_REDIR_PAUSED = 72&
  ERROR_FILE_EXISTS = 80&
  ERROR_CANNOT_MAKE = 82&
  ERROR_FAIL_I24 = 83&
  ERROR_OUT_OF_STRUCTURES = 84&
  ERROR_ALREADY_ASSIGNED = 85&
  ERROR_INVALID_PASSWORD = 86&
  ERROR_INVALID_PARAMETER = 87& 'dderror
  ERROR_NET_WRITE_FAULT = 88&
  ERROR_NO_PROC_SLOTS = 89&
  ERROR_TOO_MANY_SEMAPHORES = 100&
  ERROR_EXCL_SEM_ALREADY_OWNED = 101&
  ERROR_SEM_IS_SET = 102&
  ERROR_TOO_MANY_SEM_REQUESTS = 103&
  ERROR_SEM_OWNER_DIED = 105&
  ERROR_SEM_USER_LIMIT = 106&
  ERROR_DISK_CHANGE = 107&
  ERROR_DRIVE_LOCKED = 108&
  ERROR_BROKEN_PIPE = 109&
  ERROR_OPEN_FAILED = 110&
  ERROR_BUFFER_OVERFLOW = 111&
  ERROR_DISK_FULL = 112&
  ERROR_NO_MORE_SEARCH_HANDLES = 113&
  ERROR_INVALID_TARGET_HANDLE = 114&
  ERROR_INVALID_CATEGORY = 117&
  ERROR_INVALID_VERIFY_SWITCH = 118&
  ERROR_BAD_DRIVER_LEVEL = 119&
  ERROR_CALL_NOT_IMPLEMENTED = 120&
  ERROR_SEM_TIMEOUT = 121&
  ERROR_INSUFFICIENT_BUFFER = 122& 'dderror
  ERROR_INVALID_NAME = 123&
  ERROR_INVALID_LEVEL = 124&
  ERROR_NO_VOLUME_LABEL = 125&
  ERROR_MOD_NOT_FOUND = 126&
  ERROR_PROC_NOT_FOUND = 127&
  ERROR_WAIT_NO_CHILDREN = 128&
  ERROR_CHILD_NOT_COMPLETE = 129&
  ERROR_DIRECT_ACCESS_HANDLE = 130&
  ERROR_NEGATIVE_SEEK = 131&
  ERROR_SEEK_ON_DEVICE = 132&
  ERROR_IS_JOIN_TARGET = 133&
  ERROR_IS_JOINED = 134&
  ERROR_IS_SUBSTED = 135&
  ERROR_NOT_JOINED = 136&
  ERROR_NOT_SUBSTED = 137&
  ERROR_JOIN_TO_JOIN = 138&
  ERROR_SUBST_TO_SUBST = 139&
  ERROR_JOIN_TO_SUBST = 140&
  ERROR_SUBST_TO_JOIN = 141&
  ERROR_BUSY_DRIVE = 142&
  ERROR_SAME_DRIVE = 143&
  ERROR_DIR_NOT_ROOT = 144&
  ERROR_DIR_NOT_EMPTY = 145&
  ERROR_IS_SUBST_PATH = 146&
  ERROR_IS_JOIN_PATH = 147&
  ERROR_PATH_BUSY = 148&
  ERROR_IS_SUBST_TARGET = 149&
  ERROR_SYSTEM_TRACE = 150&
  ERROR_INVALID_EVENT_COUNT = 151&
  ERROR_TOO_MANY_MUXWAITERS = 152&
  ERROR_INVALID_LIST_FORMAT = 153&
  ERROR_LABEL_TOO_LONG = 154&
  ERROR_TOO_MANY_TCBS = 155&
  ERROR_SIGNAL_REFUSED = 156&
  ERROR_DISCARDED = 157&
  ERROR_NOT_LOCKED = 158&
  ERROR_BAD_THREADID_ADDR = 159&
  ERROR_BAD_ARGUMENTS = 160&
  ERROR_BAD_PATHNAME = 161&
  ERROR_SIGNAL_PENDING = 162&
  ERROR_MAX_THRDS_REACHED = 164&
  ERROR_LOCK_FAILED = 167&
  ERROR_BUSY = 170&
  ERROR_CANCEL_VIOLATION = 173&
  ERROR_INVALID_SEGMENT_NUMBER = 180&
  ERROR_INVALID_ORDINAL = 182&
  ERROR_ALREADY_EXISTS = 183&
  ERROR_INVALID_FLAG_NUMBER = 186&
  ERROR_SEM_NOT_FOUND = 187&
  ERROR_INVALID_STACKSEG = 189&
  ERROR_INVALID_MODULETYPE = 190&
  ERROR_INVALID_EXE_SIGNATURE = 191&
  ERROR_EXE_MARKED_INVALID = 192&
  ERROR_BAD_EXE_FORMAT = 193&
  ERROR_INVALID_MINALLOCSIZE = 195&
  ERROR_IOPL_NOT_ENABLED = 197&
  ERROR_INVALID_SEGDPL = 198&
  ERROR_AUTODATASEG_EXCEEDS_64k = 199&
  ERROR_INFLOOP_IN_RELOC_CHAIN = 202&
  ERROR_ENVVAR_NOT_FOUND = 203&
  ERROR_NO_SIGNAL_SENT = 205&
  ERROR_FILENAME_EXCED_RANGE = 206&
  ERROR_RING2_STACK_IN_USE = 207&
  ERROR_META_EXPANSION_TOO_LONG = 208&
  ERROR_INVALID_SIGNAL_NUMBER = 209&
  ERROR_THREAD_1_INACTIVE = 210&
  ERROR_LOCKED = 212&
  ERROR_TOO_MANY_MODULES = 214&
  ERROR_NESTING_NOT_ALLOWED = 215&
  ERROR_BAD_PIPE = 230&
  ERROR_PIPE_BUSY = 231&
  ERROR_NO_DATA = 232&
  ERROR_PIPE_NOT_CONNECTED = 233&
  ERROR_MORE_DATA = 234& 'dderror
  ERROR_VC_DISCONNECTED = 240&
  ERROR_INVALID_EA_NAME = 254&
  ERROR_EA_LIST_INCONSISTENT = 255&
  ERROR_NO_MORE_ITEMS = 259&
  ERROR_CANNOT_COPY = 266&
  ERROR_DIRECTORY = 267&
  ERROR_EAS_DIDNT_FIT = 275&
  ERROR_EA_FILE_CORRUPT = 276&
  ERROR_EA_TABLE_FULL = 277&
  ERROR_INVALID_EA_HANDLE = 278&
  ERROR_EAS_NOT_SUPPORTED = 282&
  ERROR_NOT_OWNER = 288&
  ERROR_TOO_MANY_POSTS = 298&
  ERROR_PARTIAL_COPY = 299&
  ERROR_OPLOCK_NOT_GRANTED = 300&
  ERROR_INVALID_OPLOCK_PROTOCOL = 301&
  ERROR_MR_MID_NOT_FOUND = 317&
  ERROR_INVALID_ADDRESS = 487&
  ERROR_ARITHMETIC_OVERFLOW = 534&
  ERROR_PIPE_CONNECTED = 535&
  ERROR_PIPE_LISTENING = 536&
  ERROR_EA_ACCESS_DENIED = 994&
  ERROR_OPERATION_ABORTED = 995&
  ERROR_IO_INCOMPLETE = 996&
  ERROR_IO_PENDING = 997& 'dderror
  ERROR_NOACCESS = 998&
  ERROR_SWAPERROR = 999&
  ERROR_STACK_OVERFLOW = 1001&
  ERROR_INVALID_MESSAGE = 1002&
  ERROR_CAN_NOT_COMPLETE = 1003&
  ERROR_INVALID_FLAGS = 1004&
  ERROR_UNRECOGNIZED_VOLUME = 1005&
  ERROR_FILE_INVALID = 1006&
  ERROR_FULLSCREEN_MODE = 1007&
  ERROR_NO_TOKEN = 1008&
  ERROR_BADDB = 1009&
  ERROR_BADKEY = 1010&
  ERROR_CANTOPEN = 1011&
  ERROR_CANTREAD = 1012&
  ERROR_CANTWRITE = 1013&
  ERROR_REGISTRY_RECOVERED = 1014&
  ERROR_REGISTRY_CORRUPT = 1015&
  ERROR_REGISTRY_IO_FAILED = 1016&
  ERROR_NOT_REGISTRY_FILE = 1017&
  ERROR_KEY_DELETED = 1018&
  ERROR_NO_LOG_SPACE = 1019&
  ERROR_KEY_HAS_CHILDREN = 1020&
  ERROR_CHILD_MUST_BE_VOLATILE = 1021&
  ERROR_NOTIFY_ENUM_DIR = 1022&
  ERROR_INVALID_SERVICE_CONTROL = 1052&
  ERROR_SERVICE_REQUEST_TIMEOUT = 1053&
  ERROR_SERVICE_NO_THREAD = 1054&
  ERROR_SERVICE_DATABASE_LOCKED = 1055&
  ERROR_SERVICE_ALREADY_RUNNING = 1056&
  ERROR_INVALID_SERVICE_ACCOUNT = 1057&
  ERROR_SERVICE_DISABLED = 1058&
  ERROR_CIRCULAR_DEPENDENCY = 1059&
  ERROR_SERVICE_DOES_NOT_EXIST = 1060&
  ERROR_SERVICE_NOT_ACTIVE = 1062&
  ERROR_EXCEPTION_IN_SERVICE = 1064&
  ERROR_DATABASE_DOES_NOT_EXIST = 1065&
  ERROR_SERVICE_SPECIFIC_ERROR = 1066&
  ERROR_PROCESS_ABORTED = 1067&
  ERROR_SERVICE_DEPENDENCY_FAIL = 1068&
  ERROR_SERVICE_LOGON_FAILED = 1069&
  ERROR_SERVICE_START_HANG = 1070&
  ERROR_INVALID_SERVICE_LOCK = 1071&
  ERROR_SERVICE_EXISTS = 1073&
  ERROR_ALREADY_RUNNING_LKG = 1074&
  ERROR_BOOT_ALREADY_ACCEPTED = 1076&
  ERROR_SERVICE_NEVER_STARTED = 1077&
  ERROR_DUPLICATE_SERVICE_NAME = 1078&
  ERROR_NO_RECOVERY_PROGRAM = 1082&
  ERROR_END_OF_MEDIA = 1100&
  ERROR_FILEMARK_DETECTED = 1101&
  ERROR_BEGINNING_OF_MEDIA = 1102&
  ERROR_SETMARK_DETECTED = 1103&
  ERROR_NO_DATA_DETECTED = 1104&
  ERROR_PARTITION_FAILURE = 1105&
  ERROR_INVALID_BLOCK_LENGTH = 1106&
  ERROR_DEVICE_NOT_PARTITIONED = 1107&
  ERROR_UNABLE_TO_LOCK_MEDIA = 1108&
  ERROR_UNABLE_TO_UNLOAD_MEDIA = 1109&
  ERROR_MEDIA_CHANGED = 1110&
  ERROR_BUS_RESET = 1111&
  ERROR_NO_MEDIA_IN_DRIVE = 1112&
  ERROR_NO_UNICODE_TRANSLATION = 1113&
  ERROR_DLL_INIT_FAILED = 1114&
  ERROR_SHUTDOWN_IN_PROGRESS = 1115&
  ERROR_NO_SHUTDOWN_IN_PROGRESS = 1116&
  ERROR_IO_DEVICE = 1117&
  ERROR_SERIAL_NO_DEVICE = 1118&
  ERROR_IRQ_BUSY = 1119&
  ERROR_MORE_WRITES = 1120&
  ERROR_COUNTER_TIMEOUT = 1121&
  ERROR_FLOPPY_WRONG_CYLINDER = 1123&
  ERROR_FLOPPY_UNKNOWN_ERROR = 1124&
  ERROR_FLOPPY_BAD_REGISTERS = 1125&
  ERROR_DISK_RECALIBRATE_FAILED = 1126&
  ERROR_DISK_OPERATION_FAILED = 1127&
  ERROR_DISK_RESET_FAILED = 1128&
  ERROR_EOM_OVERFLOW = 1129&
  ERROR_POSSIBLE_DEADLOCK = 1131&
  ERROR_MAPPED_ALIGNMENT = 1132&
  ERROR_SET_POWER_STATE_VETOED = 1140&
  ERROR_SET_POWER_STATE_FAILED = 1141&
  ERROR_TOO_MANY_LINKS = 1142&
  ERROR_OLD_WIN_VERSION = 1150&
  ERROR_APP_WRONG_OS = 1151&
  ERROR_SINGLE_INSTANCE_APP = 1152&
  ERROR_RMODE_APP = 1153&
  ERROR_INVALID_DLL = 1154&
  ERROR_NO_ASSOCIATION = 1155&
  ERROR_DDE_FAIL = 1156&
  ERROR_DLL_NOT_FOUND = 1157&
  ERROR_NO_MORE_USER_HANDLES = 1158&
  ERROR_MESSAGE_SYNC_ONLY = 1159&
  ERROR_SOURCE_ELEMENT_EMPTY = 1160&
  ERROR_ILLEGAL_ELEMENT_ADDRESS = 1162&
  ERROR_MAGAZINE_NOT_PRESENT = 1163&
  ERROR_DEVICE_REINITIALIZATION_NEEDED = 1164& 'dderror
  ERROR_DEVICE_DOOR_OPEN = 1166&
  ERROR_DEVICE_NOT_CONNECTED = 1167&
  ERROR_NOT_FOUND = 1168&
  ERROR_NO_MATCH = 1169&
  ERROR_SET_NOT_FOUND = 1170&
  ERROR_POINT_NOT_FOUND = 1171&
  ERROR_NO_TRACKING_SERVICE = 1172&
  ERROR_NO_VOLUME_ID = 1173&
  'Winnet32 Status Codes
  ERROR_BAD_USERNAME = 2202&
  ERROR_NOT_CONNECTED = 2250&
  ERROR_OPEN_FILES = 2401&
  ERROR_ACTIVE_CONNECTIONS = 2402&
  ERROR_DEVICE_IN_USE = 2404&
  ERROR_BAD_DEVICE = 1200&
  ERROR_CONNECTION_UNAVAIL = 1201&
  ERROR_NO_NET_OR_BAD_PATH = 1203&
  ERROR_BAD_PROVIDER = 1204&
  ERROR_CANNOT_OPEN_PROFILE = 1205&
  ERROR_BAD_PROFILE = 1206&
  ERROR_NOT_CONTAINER = 1207&
  ERROR_EXTENDED_ERROR = 1208&
  ERROR_INVALID_GROUPNAME = 1209&
  ERROR_INVALID_COMPUTERNAME = 1210&
  ERROR_INVALID_EVENTNAME = 1211&
  ERROR_INVALID_DOMAINNAME = 1212&
  ERROR_INVALID_SERVICENAME = 1213&
  ERROR_INVALID_NETNAME = 1214&
  ERROR_INVALID_SHARENAME = 1215&
  ERROR_INVALID_PASSWORDNAME = 1216&
  ERROR_INVALID_MESSAGENAME = 1217&
  ERROR_INVALID_MESSAGEDEST = 1218&
  ERROR_DUP_DOMAINNAME = 1221&
  ERROR_NO_NETWORK = 1222&
  ERROR_CANCELLED = 1223&
  ERROR_USER_MAPPED_FILE = 1224&
  ERROR_CONNECTION_REFUSED = 1225&
  ERROR_GRACEFUL_DISCONNECT = 1226&
  ERROR_ADDRESS_NOT_ASSOCIATED = 1228&
  ERROR_CONNECTION_INVALID = 1229&
  ERROR_CONNECTION_ACTIVE = 1230&
  ERROR_NETWORK_UNREACHABLE = 1231&
  ERROR_HOST_UNREACHABLE = 1232&
  ERROR_PROTOCOL_UNREACHABLE = 1233&
  ERROR_PORT_UNREACHABLE = 1234&
  ERROR_REQUEST_ABORTED = 1235&
  ERROR_CONNECTION_ABORTED = 1236&
  ERROR_RETRY = 1237&
  ERROR_CONNECTION_COUNT_LIMIT = 1238&
  ERROR_LOGIN_TIME_RESTRICTION = 1239&
  ERROR_LOGIN_WKSTA_RESTRICTION = 1240&
  ERROR_INCORRECT_ADDRESS = 1241&
  ERROR_ALREADY_REGISTERED = 1242&
  ERROR_SERVICE_NOT_FOUND = 1243&
  ERROR_NOT_AUTHENTICATED = 1244&
  ERROR_NOT_LOGGED_ON = 1245&
  ERROR_CONTINUE = 1246&
  ERROR_ALREADY_INITIALIZED = 1247&
  ERROR_NO_MORE_DEVICES = 1248&
  ERROR_NO_SUCH_SITE = 1249&
  ERROR_DS_NOT_INSTALLED = 1251&
  'Security Status Codes
  ERROR_NOT_ALL_ASSIGNED = 1300&
  ERROR_SOME_NOT_MAPPED = 1301&
  ERROR_NO_QUOTAS_FOR_ACCOUNT = 1302&
  ERROR_LOCAL_USER_SESSION_KEY = 1303&
  ERROR_NULL_LM_PASSWORD = 1304&
  ERROR_UNKNOWN_REVISION = 1305&
  ERROR_REVISION_MISMATCH = 1306&
  ERROR_INVALID_OWNER = 1307&
  ERROR_INVALID_PRIMARY_GROUP = 1308&
  ERROR_NO_IMPERSONATION_TOKEN = 1309&
  ERROR_CANT_DISABLE_MANDATORY = 1310&
  ERROR_NO_LOGON_SERVERS = 1311&
  ERROR_NO_SUCH_LOGON_SESSION = 1312&
  ERROR_NO_SUCH_PRIVILEGE = 1313&
  ERROR_PRIVILEGE_NOT_HELD = 1314&
  ERROR_INVALID_ACCOUNT_NAME = 1315&
  ERROR_USER_EXISTS = 1316&
  ERROR_NO_SUCH_USER = 1317&
  ERROR_GROUP_EXISTS = 1318&
  ERROR_NO_SUCH_GROUP = 1319&
  ERROR_MEMBER_IN_GROUP = 1320&
  ERROR_MEMBER_NOT_IN_GROUP = 1321&
  ERROR_LAST_ADMIN = 1322&
  ERROR_WRONG_PASSWORD = 1323&
  ERROR_ILL_FORMED_PASSWORD = 1324&
  ERROR_PASSWORD_RESTRICTION = 1325&
  ERROR_LOGON_FAILURE = 1326&
  ERROR_ACCOUNT_RESTRICTION = 1327&
  ERROR_INVALID_LOGON_HOURS = 1328&
  ERROR_INVALID_WORKSTATION = 1329&
  ERROR_PASSWORD_EXPIRED = 1330&
  ERROR_ACCOUNT_DISABLED = 1331&
  ERROR_NONE_MAPPED = 1332&
  ERROR_LUIDS_EXHAUSTED = 1334&
  ERROR_INVALID_SUB_AUTHORITY = 1335&
  ERROR_INVALID_ACL = 1336&
  ERROR_INVALID_SID = 1337&
  ERROR_INVALID_SECURITY_DESCR = 1338&
  ERROR_BAD_INHERITANCE_ACL = 1340&
  ERROR_SERVER_DISABLED = 1341&
  ERROR_SERVER_NOT_DISABLED = 1342&
  ERROR_INVALID_ID_AUTHORITY = 1343&
  ERROR_ALLOTTED_SPACE_EXCEEDED = 1344&
  ERROR_BAD_IMPERSONATION_LEVEL = 1346&
  ERROR_CANT_OPEN_ANONYMOUS = 1347&
  ERROR_BAD_VALIDATION_CLASS = 1348&
  ERROR_BAD_TOKEN_TYPE = 1349&
  ERROR_NO_SECURITY_ON_OBJECT = 1350&
  ERROR_CANT_ACCESS_DOMAIN_INFO = 1351&
  ERROR_INVALID_SERVER_STATE = 1352&
  ERROR_INVALID_DOMAIN_STATE = 1353&
  ERROR_INVALID_DOMAIN_ROLE = 1354&
  ERROR_NO_SUCH_DOMAIN = 1355&
  ERROR_DOMAIN_EXISTS = 1356&
  ERROR_DOMAIN_LIMIT_EXCEEDED = 1357&
  ERROR_INTERNAL_DB_CORRUPTION = 1358&
  ERROR_INTERNAL_ERROR = 1359&
  ERROR_GENERIC_NOT_MAPPED = 1360&
  ERROR_BAD_DESCRIPTOR_FORMAT = 1361&
  ERROR_NOT_LOGON_PROCESS = 1362&
  ERROR_LOGON_SESSION_EXISTS = 1363&
  ERROR_NO_SUCH_PACKAGE = 1364&
  ERROR_BAD_LOGON_SESSION_STATE = 1365&
  ERROR_LOGON_SESSION_COLLISION = 1366&
  ERROR_INVALID_LOGON_TYPE = 1367&
  ERROR_CANNOT_IMPERSONATE = 1368&
  ERROR_RXACT_INVALID_STATE = 1369&
  ERROR_RXACT_COMMIT_FAILURE = 1370&
  ERROR_SPECIAL_ACCOUNT = 1371&
  ERROR_SPECIAL_GROUP = 1372&
  ERROR_SPECIAL_USER = 1373&
  ERROR_MEMBERS_PRIMARY_GROUP = 1374&
  ERROR_TOKEN_ALREADY_IN_USE = 1375&
  ERROR_NO_SUCH_ALIAS = 1376&
  ERROR_MEMBER_NOT_IN_ALIAS = 1377&
  ERROR_MEMBER_IN_ALIAS = 1378&
  ERROR_ALIAS_EXISTS = 1379&
  ERROR_LOGON_NOT_GRANTED = 1380&
  ERROR_TOO_MANY_SECRETS = 1381&
  ERROR_SECRET_TOO_LONG = 1382&
  ERROR_INTERNAL_DB_ERROR = 1383&
  ERROR_TOO_MANY_CONTEXT_IDS = 1384&
  ERROR_LOGON_TYPE_NOT_GRANTED = 1385&
  ERROR_NO_SUCH_MEMBER = 1387&
  ERROR_INVALID_MEMBER = 1388&
  ERROR_TOO_MANY_SIDS = 1389&
  ERROR_NO_INHERITANCE = 1391&
  ERROR_FILE_CORRUPT = 1392&
  ERROR_DISK_CORRUPT = 1393&
  ERROR_NO_USER_SESSION_KEY = 1394&
  ERROR_LICENSE_QUOTA_EXCEEDED = 1395&
  'WinUser Error Codes
  ERROR_INVALID_WINDOW_HANDLE = 1400&
  ERROR_INVALID_MENU_HANDLE = 1401&
  ERROR_INVALID_CURSOR_HANDLE = 1402&
  ERROR_INVALID_ACCEL_HANDLE = 1403&
  ERROR_INVALID_HOOK_HANDLE = 1404&
  ERROR_INVALID_DWP_HANDLE = 1405&
  ERROR_TLW_WITH_WSCHILD = 1406&
  ERROR_CANNOT_FIND_WND_CLASS = 1407&
  ERROR_WINDOW_OF_OTHER_THREAD = 1408&
  ERROR_CLASS_ALREADY_EXISTS = 1410&
  ERROR_CLASS_DOES_NOT_EXIST = 1411&
  ERROR_CLASS_HAS_WINDOWS = 1412&
  ERROR_INVALID_INDEX = 1413&
  ERROR_INVALID_ICON_HANDLE = 1414&
  ERROR_PRIVATE_DIALOG_INDEX = 1415&
  ERROR_LISTBOX_ID_NOT_FOUND = 1416&
  ERROR_NO_WILDCARD_CHARACTERS = 1417&
  ERROR_CLIPBOARD_NOT_OPEN = 1418&
  ERROR_HOTKEY_NOT_REGISTERED = 1419&
  ERROR_WINDOW_NOT_DIALOG = 1420&
  ERROR_CONTROL_ID_NOT_FOUND = 1421&
  ERROR_WINDOW_NOT_COMBOBOX = 1423&
  ERROR_INVALID_EDIT_HEIGHT = 1424&
  ERROR_DC_NOT_FOUND = 1425&
  ERROR_INVALID_HOOK_FILTER = 1426&
  ERROR_INVALID_FILTER_PROC = 1427&
  ERROR_HOOK_NEEDS_HMOD = 1428&
  ERROR_GLOBAL_ONLY_HOOK = 1429&
  ERROR_JOURNAL_HOOK_SET = 1430&
  ERROR_HOOK_NOT_INSTALLED = 1431&
  ERROR_INVALID_LB_MESSAGE = 1432&
  ERROR_SETCOUNT_ON_BAD_LB = 1433&
  ERROR_LB_WITHOUT_TABSTOPS = 1434&
  ERROR_CHILD_WINDOW_MENU = 1436&
  ERROR_NO_SYSTEM_MENU = 1437&
  ERROR_INVALID_MSGBOX_STYLE = 1438&
  ERROR_INVALID_SPI_VALUE = 1439&
  ERROR_SCREEN_ALREADY_LOCKED = 1440&
  ERROR_HWNDS_HAVE_DIFF_PARENT = 1441&
  ERROR_NOT_CHILD_WINDOW = 1442&
  ERROR_INVALID_GW_COMMAND = 1443&
  ERROR_INVALID_THREAD_ID = 1444&
  ERROR_NON_MDICHILD_WINDOW = 1445&
  ERROR_POPUP_ALREADY_ACTIVE = 1446&
  ERROR_NO_SCROLLBARS = 1447&
  ERROR_INVALID_SCROLLBAR_RANGE = 1448&
  ERROR_INVALID_SHOWWIN_COMMAND = 1449&
  ERROR_NO_SYSTEM_RESOURCES = 1450&
  ERROR_PAGED_SYSTEM_RESOURCES = 1452&
  ERROR_WORKING_SET_QUOTA = 1453&
  ERROR_PAGEFILE_QUOTA = 1454&
  ERROR_COMMITMENT_LIMIT = 1455&
  ERROR_MENU_ITEM_NOT_FOUND = 1456&
  ERROR_INVALID_KEYBOARD_HANDLE = 1457&
  ERROR_HOOK_TYPE_NOT_ALLOWED = 1458&
  ERROR_TIMEOUT = 1460&
  ERROR_INVALID_MONITOR_HANDLE = 1461&
  'Eventlog Status Codes
  ERROR_EVENTLOG_FILE_CORRUPT = 1500&
  ERROR_EVENTLOG_CANT_START = 1501&
  ERROR_LOG_FILE_FULL = 1502&
  ERROR_EVENTLOG_FILE_CHANGED = 1503&
  'MSI Error Codes
  ERROR_INSTALL_SERVICE = 1601&
  ERROR_INSTALL_USEREXIT = 1602&
  ERROR_INSTALL_FAILURE = 1603&
  ERROR_INSTALL_SUSPEND = 1604&
  ERROR_UNKNOWN_PRODUCT = 1605&
  ERROR_UNKNOWN_FEATURE = 1606&
  ERROR_UNKNOWN_COMPONENT = 1607&
  ERROR_UNKNOWN_PROPERTY = 1608&
  ERROR_INVALID_HANDLE_STATE = 1609&
  ERROR_BAD_CONFIGURATION = 1610&
  ERROR_INDEX_ABSENT = 1611&
  ERROR_INSTALL_SOURCE_ABSENT = 1612&
  ERROR_BAD_DATABASE_VERSION = 1613&
  ERROR_PRODUCT_UNINSTALLED = 1614&
  ERROR_BAD_QUERY_SYNTAX = 1615&
  ERROR_INVALID_FIELD = 1616&
  'RPC Status Codes
  RPC_S_INVALID_STRING_BINDING = 1700&
  RPC_S_WRONG_KIND_OF_BINDING = 1701&
  RPC_S_INVALID_BINDING = 1702&
  RPC_S_PROTSEQ_NOT_SUPPORTED = 1703&
  RPC_S_INVALID_RPC_PROTSEQ = 1704&
  RPC_S_INVALID_STRING_UUID = 1705&
  RPC_S_INVALID_ENDPOINT_FORMAT = 1706&
  RPC_S_INVALID_NET_ADDR = 1707&
  RPC_S_NO_ENDPOINT_FOUND = 1708&
  RPC_S_INVALID_TIMEOUT = 1709&
  RPC_S_OBJECT_NOT_FOUND = 1710&
  RPC_S_ALREADY_REGISTERED = 1711&
  RPC_S_TYPE_ALREADY_REGISTERED = 1712&
  RPC_S_ALREADY_LISTENING = 1713&
  RPC_S_NO_PROTSEQS_REGISTERED = 1714&
  RPC_S_NOT_LISTENING = 1715&
  RPC_S_UNKNOWN_MGR_TYPE = 1716&
  RPC_S_UNKNOWN_IF = 1717&
  RPC_S_NO_BINDINGS = 1718&
  RPC_S_NO_PROTSEQS = 1719&
  RPC_S_CANT_CREATE_ENDPOINT = 1720&
  RPC_S_OUT_OF_RESOURCES = 1721&
  RPC_S_SERVER_UNAVAILABLE = 1722&
  RPC_S_SERVER_TOO_BUSY = 1723&
  RPC_S_INVALID_NETWORK_OPTIONS = 1724&
  RPC_S_NO_CALL_ACTIVE = 1725&
  RPC_S_CALL_FAILED = 1726&
  RPC_S_CALL_FAILED_DNE = 1727&
  RPC_S_PROTOCOL_ERROR = 1728&
  RPC_S_UNSUPPORTED_TRANS_SYN = 1730&
  RPC_S_UNSUPPORTED_TYPE = 1732&
  RPC_S_INVALID_TAG = 1733&
  RPC_S_INVALID_BOUND = 1734&
  RPC_S_NO_ENTRY_NAME = 1735&
  RPC_S_INVALID_NAME_SYNTAX = 1736&
  RPC_S_UNSUPPORTED_NAME_SYNTAX = 1737&
  RPC_S_UUID_NO_ADDRESS = 1739&
  RPC_S_DUPLICATE_ENDPOINT = 1740&
  RPC_S_UNKNOWN_AUTHN_TYPE = 1741&
  RPC_S_MAX_CALLS_TOO_SMALL = 1742&
  RPC_S_STRING_TOO_LONG = 1743&
  RPC_S_PROTSEQ_NOT_FOUND = 1744&
  RPC_S_PROCNUM_OUT_OF_RANGE = 1745&
  RPC_S_BINDING_HAS_NO_AUTH = 1746&
  RPC_S_UNKNOWN_AUTHN_SERVICE = 1747&
  RPC_S_UNKNOWN_AUTHN_LEVEL = 1748&
  RPC_S_INVALID_AUTH_IDENTITY = 1749&
  RPC_S_UNKNOWN_AUTHZ_SERVICE = 1750&
  EPT_S_INVALID_ENTRY = 1751&
  EPT_S_CANT_PERFORM_OP = 1752&
  EPT_S_NOT_REGISTERED = 1753&
  RPC_S_NOTHING_TO_EXPORT = 1754&
  RPC_S_INCOMPLETE_NAME = 1755&
  RPC_S_INVALID_VERS_OPTION = 1756&
  RPC_S_NO_MORE_MEMBERS = 1757&
  RPC_S_NOT_ALL_OBJS_UNEXPORTED = 1758&
  RPC_S_INTERFACE_NOT_FOUND = 1759&
  RPC_S_ENTRY_ALREADY_EXISTS = 1760&
  RPC_S_ENTRY_NOT_FOUND = 1761&
  RPC_S_INVALID_NAF_ID = 1763&
  RPC_S_CANNOT_SUPPORT = 1764&
  RPC_S_NO_CONTEXT_AVAILABLE = 1765&
  RPC_S_INTERNAL_ERROR = 1766&
  RPC_S_ZERO_DIVIDE = 1767&
  RPC_S_ADDRESS_ERROR = 1768&
  RPC_S_FP_DIV_ZERO = 1769&
  RPC_S_FP_UNDERFLOW = 1770&
  RPC_S_FP_OVERFLOW = 1771&
  RPC_X_NO_MORE_ENTRIES = 1772&
  RPC_X_SS_CHAR_TRANS_OPEN_FAIL = 1773&
  RPC_X_SS_IN_NULL_CONTEXT = 1775&
  RPC_X_SS_CONTEXT_DAMAGED = 1777&
  RPC_X_SS_HANDLES_MISMATCH = 1778&
  RPC_X_NULL_REF_POINTER = 1780&
  RPC_X_ENUM_VALUE_OUT_OF_RANGE = 1781&
  RPC_X_BYTE_COUNT_TOO_SMALL = 1782&
  RPC_X_BAD_STUB_DATA = 1783&
  ERROR_INVALID_USER_BUFFER = 1784&
  ERROR_UNRECOGNIZED_MEDIA = 1785&
  ERROR_NO_TRUST_LSA_SECRET = 1786&
  ERROR_NO_TRUST_SAM_ACCOUNT = 1787&
  ERROR_TRUSTED_DOMAIN_FAILURE = 1788&
  ERROR_TRUST_FAILURE = 1790&
  RPC_S_CALL_IN_PROGRESS = 1791&
  ERROR_NETLOGON_NOT_STARTED = 1792&
  ERROR_ACCOUNT_EXPIRED = 1793&
  ERROR_UNKNOWN_PORT = 1796&
  ERROR_UNKNOWN_PRINTER_DRIVER = 1797&
  ERROR_UNKNOWN_PRINTPROCESSOR = 1798&
  ERROR_INVALID_SEPARATOR_FILE = 1799&
  ERROR_INVALID_PRIORITY = 1800&
  ERROR_INVALID_PRINTER_NAME = 1801&
  ERROR_PRINTER_ALREADY_EXISTS = 1802&
  ERROR_INVALID_PRINTER_COMMAND = 1803&
  ERROR_INVALID_DATATYPE = 1804&
  ERROR_INVALID_ENVIRONMENT = 1805&
  RPC_S_NO_MORE_BINDINGS = 1806&
  ERROR_SERVER_HAS_OPEN_HANDLES = 1811&
  ERROR_RESOURCE_DATA_NOT_FOUND = 1812&
  ERROR_RESOURCE_TYPE_NOT_FOUND = 1813&
  ERROR_RESOURCE_NAME_NOT_FOUND = 1814&
  ERROR_RESOURCE_LANG_NOT_FOUND = 1815&
  ERROR_NOT_ENOUGH_QUOTA = 1816&
  RPC_S_NO_INTERFACES = 1817&
  RPC_S_CALL_CANCELLED = 1818&
  RPC_S_BINDING_INCOMPLETE = 1819&
  RPC_S_COMM_FAILURE = 1820&
  RPC_S_UNSUPPORTED_AUTHN_LEVEL = 1821&
  RPC_S_NO_PRINC_NAME = 1822&
  RPC_S_NOT_RPC_ERROR = 1823&
  RPC_S_UUID_LOCAL_ONLY = 1824&
  RPC_S_SEC_PKG_ERROR = 1825&
  RPC_S_NOT_CANCELLED = 1826&
  RPC_X_INVALID_ES_ACTION = 1827&
  RPC_X_WRONG_ES_VERSION = 1828&
  RPC_X_WRONG_STUB_VERSION = 1829&
  RPC_X_INVALID_PIPE_OBJECT = 1830&
  RPC_X_WRONG_PIPE_ORDER = 1831&
  RPC_X_WRONG_PIPE_VERSION = 1832&
  RPC_S_GROUP_MEMBER_NOT_FOUND = 1898&
  EPT_S_CANT_CREATE = 1899&
  RPC_S_INVALID_OBJECT = 1900&
  ERROR_INVALID_TIME = 1901&
  ERROR_INVALID_FORM_NAME = 1902&
  ERROR_INVALID_FORM_SIZE = 1903&
  ERROR_ALREADY_WAITING = 1904&
  ERROR_PRINTER_DELETED = 1905&
  ERROR_INVALID_PRINTER_STATE = 1906&
  ERROR_PASSWORD_MUST_CHANGE = 1907&
  ERROR_ACCOUNT_LOCKED_OUT = 1909&
  OR_INVALID_OXID = 1910&
  OR_INVALID_OID = 1911&
  OR_INVALID_SET = 1912&
  RPC_S_SEND_INCOMPLETE = 1913&
  RPC_S_INVALID_ASYNC_HANDLE = 1914&
  RPC_S_INVALID_ASYNC_CALL = 1915&
  RPC_X_PIPE_CLOSED = 1916&
  RPC_X_PIPE_DISCIPLINE_ERROR = 1917&
  RPC_X_PIPE_EMPTY = 1918&
  ERROR_NO_SITENAME = 1919&
  ERROR_CANT_ACCESS_FILE = 1920&
  ERROR_CANT_RESOLVE_FILENAME = 1921&
  ERROR_DS_BUSY = 1927&
  ERROR_DS_UNAVAILABLE = 1928&
  ERROR_DS_NO_RIDS_ALLOCATED = 1929&
  ERROR_DS_NO_MORE_RIDS = 1930&
  ERROR_DS_INCORRECT_ROLE_OWNER = 1931&
  ERROR_DS_RIDMGR_INIT_ERROR = 1932&
  ERROR_DS_OBJ_CLASS_VIOLATION = 1933&
  ERROR_DS_CANT_ON_NON_LEAF = 1934&
  ERROR_DS_CANT_ON_RDN = 1935&
  ERROR_DS_CANT_MOD_OBJ_CLASS = 1936&
  ERROR_DS_CROSS_DOM_MOVE_ERROR = 1937&
  ERROR_DS_GC_NOT_AVAILABLE = 1938&
  'OpenGL Error Code
  ERROR_INVALID_PIXEL_FORMAT = 2000&
  ERROR_BAD_DRIVER = 2001&
  ERROR_INVALID_WINDOW_STYLE = 2002&
  ERROR_METAFILE_NOT_SUPPORTED = 2003&
  ERROR_TRANSFORM_NOT_SUPPORTED = 2004&
  ERROR_CLIPPING_NOT_SUPPORTED = 2005&
  'Image Color Management Error Code
  ERROR_INVALID_CMM = 2300&
  ERROR_INVALID_PROFILE = 2301&
  ERROR_TAG_NOT_FOUND = 2302&
  ERROR_TAG_NOT_PRESENT = 2303&
  ERROR_DUPLICATE_TAG = 2304&
  ERROR_PROFILE_NOT_FOUND = 2306&
  ERROR_INVALID_COLORSPACE = 2307&
  ERROR_ICM_NOT_ENABLED = 2308&
  ERROR_DELETING_ICM_XFORM = 2309&
  ERROR_INVALID_TRANSFORM = 2310&
  'Win32 Spooler Error Codes
  ERROR_UNKNOWN_PRINT_MONITOR = 3000&
  ERROR_PRINTER_DRIVER_IN_USE = 3001&
  ERROR_SPOOL_FILE_NOT_FOUND = 3002&
  ERROR_SPL_NO_STARTDOC = 3003&
  ERROR_SPL_NO_ADDJOB = 3004&
  ERROR_INVALID_PRINT_MONITOR = 3007&
  ERROR_PRINT_MONITOR_IN_USE = 3008&
  ERROR_PRINTER_HAS_JOBS_QUEUED = 3009&
  ERROR_SUCCESS_REBOOT_REQUIRED = 3010&
  'Wins Error Codes
  ERROR_WINS_INTERNAL = 4000&
  ERROR_CAN_NOT_DEL_LOCAL_WINS = 4001&
  ERROR_STATIC_INIT = 4002&
  ERROR_INC_BACKUP = 4003&
  ERROR_FULL_BACKUP = 4004&
  ERROR_REC_NON_EXISTENT = 4005&
  ERROR_RPL_NOT_ALLOWED = 4006&
  'DHCP Error Codes
  ERROR_DHCP_ADDRESS_CONFLICT = 4100&
  'WMI Error Codes
  ERROR_WMI_GUID_NOT_FOUND = 4200&
  ERROR_WMI_INSTANCE_NOT_FOUND = 4201&
  ERROR_WMI_ITEMID_NOT_FOUND = 4202&
  ERROR_WMI_TRY_AGAIN = 4203&
  ERROR_WMI_DP_NOT_FOUND = 4204&
  ERROR_WMI_ALREADY_ENABLED = 4206&
  ERROR_WMI_GUID_DISCONNECTED = 4207&
  ERROR_WMI_SERVER_UNAVAILABLE = 4208&
  ERROR_WMI_DP_FAILED = 4209&
  ERROR_WMI_INVALID_MOF = 4210&
  ERROR_WMI_INVALID_REGINFO = 4211&
  'NT Media Services Error Codes
  ERROR_INVALID_MEDIA = 4300&
  ERROR_INVALID_LIBRARY = 4301&
  ERROR_INVALID_MEDIA_POOL = 4302&
  ERROR_DRIVE_MEDIA_MISMATCH = 4303&
  ERROR_MEDIA_OFFLINE = 4304&
  ERROR_LIBRARY_OFFLINE = 4305&
  ERROR_EMPTY = 4306&
  ERROR_NOT_EMPTY = 4307&
  ERROR_MEDIA_UNAVAILABLE = 4308&
  ERROR_RESOURCE_DISABLED = 4309&
  ERROR_INVALID_CLEANER = 4310&
  ERROR_UNABLE_TO_CLEAN = 4311&
  ERROR_OBJECT_NOT_FOUND = 4312&
  ERROR_DATABASE_FAILURE = 4313&
  ERROR_DATABASE_FULL = 4314&
  ERROR_MEDIA_INCOMPATIBLE = 4315&
  ERROR_RESOURCE_NOT_PRESENT = 4316&
  ERROR_INVALID_OPERATION = 4317&
  ERROR_MEDIA_NOT_AVAILABLE = 4318&
  ERROR_DEVICE_NOT_AVAILABLE = 4319&
  ERROR_REQUEST_REFUSED = 4320&
  'NT Remote Storage Service Error Codes
  ERROR_FILE_OFFLINE = 4350&
  'NT Reparse Points Error Codes
  ERROR_NOT_A_REPARSE_POINT = 4390&
  'Cluster Error Codes
  ERROR_DEPENDENCY_NOT_FOUND = 5002&
  ERROR_RESOURCE_NOT_ONLINE = 5004&
  ERROR_HOST_NODE_NOT_AVAILABLE = 5005&
  ERROR_RESOURCE_NOT_AVAILABLE = 5006&
  ERROR_RESOURCE_NOT_FOUND = 5007&
  ERROR_SHUTDOWN_CLUSTER = 5008&
  ERROR_CANT_EVICT_ACTIVE_NODE = 5009&
  ERROR_OBJECT_ALREADY_EXISTS = 5010&
  ERROR_OBJECT_IN_LIST = 5011&
  ERROR_GROUP_NOT_AVAILABLE = 5012&
  ERROR_GROUP_NOT_FOUND = 5013&
  ERROR_GROUP_NOT_ONLINE = 5014&
  ERROR_RESMON_CREATE_FAILED = 5017&
  ERROR_RESMON_ONLINE_FAILED = 5018&
  ERROR_RESOURCE_ONLINE = 5019&
  ERROR_QUORUM_RESOURCE = 5020&
  ERROR_NOT_QUORUM_CAPABLE = 5021&
  ERROR_CLUSTER_SHUTTING_DOWN = 5022&
  ERROR_INVALID_STATE = 5023&
  ERROR_NOT_QUORUM_CLASS = 5025&
  ERROR_CORE_RESOURCE = 5026&
  ERROR_QUORUMLOG_OPEN_FAILED = 5028&
  ERROR_CLUSTERLOG_CORRUPT = 5029&
  'EFS Error Codes
  ERROR_ENCRYPTION_FAILED = 6000&
  ERROR_DECRYPTION_FAILED = 6001&
  ERROR_FILE_ENCRYPTED = 6002&
  ERROR_NO_RECOVERY_POLICY = 6003&
  ERROR_NO_EFS = 6004&
  ERROR_WRONG_EFS = 6005&
  ERROR_NO_USER_KEYS = 6006&
  ERROR_FILE_NOT_ENCRYPTED = 6007&
  ERROR_NOT_EXPORT_FORMAT = 6008&
End Enum

Private Const DELETE                          As Long = &H10000
Private Const READ_CONTROL                    As Long = &H20000
Private Const WRITE_DAC                       As Long = &H40000
Private Const WRITE_OWNER                     As Long = &H80000
Private Const SYNCHRONIZE                     As Long = &H100000
Private Const STANDARD_RIGHTS_REQUIRED        As Long = &HF0000
Private Const STANDARD_RIGHTS_READ = READ_CONTROL
Private Const STANDARD_RIGHTS_WRITE = READ_CONTROL
Private Const STANDARD_RIGHTS_EXECUTE = READ_CONTROL
Private Const STANDARD_RIGHTS_ALL             As Long = &H1F0000
Private Const SPECIFIC_RIGHTS_ALL             As Long = &HFFFF&
Private Const ACCESS_SYSTEM_SECURITY          As Long = &H1000000
Private Const MAXIMUM_ALLOWED                 As Long = &H2000000
Private Const GENERIC_READ                    As Long = &H80000000
Private Const GENERIC_WRITE                   As Long = &H40000000
Private Const GENERIC_EXECUTE                 As Long = &H20000000
Private Const GENERIC_ALL                     As Long = &H10000000

Private Const FORMAT_MESSAGE_ALLOCATE_BUFFER As Long = &H100
Private Const FORMAT_MESSAGE_FROM_SYSTEM As Long = &H1000
Private Declare Function ErrorFormatMessage Lib "kernel32" Alias "FormatMessageW" (ByVal dwFlags As Long, ByRef lpSource As Any, ByVal dwMessageId As WINAPI_ERRORS, ByVal dwLanguageId As Long, lpBuffer As Any, ByVal nSize As Long, ByRef Arguments As Long) As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDestination As Any, pSource As Any, ByVal Length As Long)
Private Declare Function GetTickCount Lib "kernel32" () As Long

Private Declare Function SetTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Private Declare Function KillTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long) As Long

Private Enum TimerModes
  ModeSvcStart
  ModeSvcStop
  ModeSvcPause
  ModeSvcContinue
End Enum

Private TimerHandle As Long, TimerMode As TimerModes

Private Enum SERVICE_TYPES
  SERVICE_TYPE_NONE = &H0&
  SERVICE_KERNEL_DRIVER = &H1&
  SERVICE_FILE_SYSTEM_DRIVER = &H2&
  SERVICE_ADAPTER = &H4&
  SERVICE_RECOGNIZER_DRIVER = &H8&
  SERVICE_DRIVER = (SERVICE_KERNEL_DRIVER Or SERVICE_FILE_SYSTEM_DRIVER Or SERVICE_RECOGNIZER_DRIVER)
  SERVICE_WIN32_OWN_PROCESS = &H10&
  SERVICE_WIN32_SHARE_PROCESS = &H20&
  SERVICE_WIN32 = (SERVICE_WIN32_OWN_PROCESS Or SERVICE_WIN32_SHARE_PROCESS)
  SERVICE_INTERACTIVE_PROCESS = &H100&
  SERVICE_TYPE_ALL = (SERVICE_WIN32 Or SERVICE_ADAPTER Or SERVICE_DRIVER Or SERVICE_INTERACTIVE_PROCESS)
End Enum

Private Enum SERVICE_STATE_MASK
  SERVICE_ACTIVE = &H1&
  SERVICE_INACTIVE = &H2&
  SERVICE_STATE_ALL = (SERVICE_ACTIVE Or SERVICE_INACTIVE)
End Enum

Private Enum SERVICE_STATES
  SERVICE_STATE_NONE = &H0&
  SERVICE_STOPPED = &H1&
  SERVICE_START_PENDING = &H2&
  SERVICE_STOP_PENDING = &H3&
  SERVICE_RUNNING = &H4&
  SERVICE_CONTINUE_PENDING = &H5&
  SERVICE_PAUSE_PENDING = &H6&
  SERVICE_PAUSED = &H7&
End Enum

Private Enum SERVICE_CONTROLS_ACCEPTED
  SERVICE_ACCEPT_NONE = &H0&
  SERVICE_ACCEPT_STOP = &H1&
  SERVICE_ACCEPT_PAUSE_CONTINUE = &H2&
  SERVICE_ACCEPT_SHUTDOWN = &H4&
  SERVICE_ACCEPT_PARAMCHANGE = &H8&
  SERVICE_ACCEPT_NETBINDCHANGE = &H10&
  SERVICE_ACCEPT_ALL = (SERVICE_ACCEPT_STOP Or SERVICE_ACCEPT_PAUSE_CONTINUE Or SERVICE_ACCEPT_SHUTDOWN Or SERVICE_ACCEPT_PARAMCHANGE Or SERVICE_ACCEPT_NETBINDCHANGE)
End Enum

Private Type SERVICE_STATUS
  dwServiceType As SERVICE_TYPES
  dwCurrentState As SERVICE_STATES
  dwControlsAccepted As SERVICE_CONTROLS_ACCEPTED
  dwWin32ExitCode As Long
  dwServiceSpecificExitCode As Long
  dwCheckPoint As Long
  dwWaitHint As Long
End Type

Private Type ENUM_SERVICE_STATUS
  lpServiceName As Long
  lpDisplayName As Long
  ServiceStatus As SERVICE_STATUS
End Type

Private Type SERVICE_STATUS_PROCESS
  dwServiceType As SERVICE_TYPES
  dwCurrentState As SERVICE_STATES
  dwControlsAccepted As SERVICE_CONTROLS_ACCEPTED
  dwWin32ExitCode As Long
  dwServiceSpecificExitCode As Long
  dwCheckPoint As Long
  dwWaitHint As Long
  dwProcessId As Long
  dwServiceFlags  As Long
End Type

Private Type ENUM_SERVICE_STATUS_PROCESS
  lpServiceName As Long
  lpDisplayName As Long
  ServiceStatusProcess  As SERVICE_STATUS_PROCESS
End Type

Private Enum SERVICE_START_TYPES
  SERVICE_BOOT_START = &H0&
  SERVICE_SYSTEM_START = &H1&
  SERVICE_AUTO_START = &H2&
  SERVICE_DEMAND_START = &H3&
  SERVICE_DISABLED = &H4&
End Enum

Private Enum SERVICE_ERROR_CONTROL_TYPES
  SERVICE_ERROR_IGNORE = &H0&
  SERVICE_ERROR_NORMAL = &H1&
  SERVICE_ERROR_SEVERE = &H2&
  SERVICE_ERROR_CRITICAL = &H3&
End Enum

Private Type QUERY_SERVICE_CONFIG
  dwServiceType As SERVICE_TYPES
  dwStartType As SERVICE_START_TYPES
  dwErrorControl As SERVICE_ERROR_CONTROL_TYPES
  lpBinaryPathName As Long
  lpLoadOrderGroup As Long
  dwTagId As Long
  lpDependencies  As Long
  lpServiceStartName As Long
  lpDisplayName  As Long
End Type

Private Type QUERY_SERVICE_LOCK_STATUS
  flsLock As Long
  lpLockOwner As Long
  dwLockDuration As Long
End Type

Private Enum SC_ACTION_TYPES
  SC_ACTION_NONE = 0
  SC_ACTION_RESTART = 1
  SC_ACTION_REBOOT = 2
  SC_ACTION_RUN_COMMAND = 3
End Enum

Private Type SC_ACTION
  Type As SC_ACTION_TYPES
  Delay As Long
End Type

Private Type SERVICE_DESCRIPTION
  lpDescription As Long
End Type

Private Type SERVICE_FAILURE_ACTIONS
  dwResetPeriod As Long
  lpRebootMsg As Long
  lpCommand As Long
  cActions As Long
  lpsaActions As Long
End Type

Private Type SERVICE_TABLE_ENTRY
  lpServiceName As Long
  lpServiceProc As Long
End Type

Private Enum SCM_ACCESS_TYPES
  SC_MANAGER_CONNECT = &H1&
  SC_MANAGER_CREATE_SERVICE = &H2&
  SC_MANAGER_ENUMERATE_SERVICE = &H4&
  SC_MANAGER_LOCK = &H8&
  SC_MANAGER_QUERY_LOCK_STATUS = &H10&
  SC_MANAGER_MODIFY_BOOT_CONFIG = &H20&
  SC_MANAGER_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED Or SC_MANAGER_CONNECT Or SC_MANAGER_CREATE_SERVICE Or SC_MANAGER_ENUMERATE_SERVICE Or SC_MANAGER_LOCK Or SC_MANAGER_QUERY_LOCK_STATUS Or SC_MANAGER_MODIFY_BOOT_CONFIG)
End Enum

Private Enum SERVICE_ACCESS_TYPES
  SERVICE_QUERY_CONFIG = &H1&
  SERVICE_CHANGE_CONFIG = &H2&
  SERVICE_QUERY_STATUS = &H4&
  SERVICE_ENUMERATE_DEPENDENTS = &H8&
  SERVICE_START = &H10&
  SERVICE_STOP = &H20&
  SERVICE_PAUSE_CONTINUE = &H40&
  SERVICE_INTERROGATE = &H80&
  SERVICE_USER_DEFINED_CONTROL = &H100&
  SERVICE_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED Or SERVICE_QUERY_CONFIG Or SERVICE_CHANGE_CONFIG Or SERVICE_QUERY_STATUS Or SERVICE_ENUMERATE_DEPENDENTS Or SERVICE_START Or SERVICE_STOP Or SERVICE_PAUSE_CONTINUE Or SERVICE_INTERROGATE Or SERVICE_USER_DEFINED_CONTROL)
End Enum

Private Enum SERVICE_CONTROL_COMMANDS
  SERVICE_CONTROL_STOP = &H1&
  SERVICE_CONTROL_PAUSE = &H2&
  SERVICE_CONTROL_CONTINUE = &H3&
  SERVICE_CONTROL_INTERROGATE = &H4&
  SERVICE_CONTROL_SHUTDOWN = &H5&
  SERVICE_CONTROL_PARAMCHANGE = &H6&
  SERVICE_CONTROL_NETBINDADD = &H7&
  SERVICE_CONTROL_NETBINDREMOVE = &H8&
  SERVICE_CONTROL_NETBINDENABLE = &H9&
  SERVICE_CONTROL_NETBINDDISABLE = &HA&
End Enum

Private Declare Function OpenSCManager Lib "advapi32" Alias "OpenSCManagerW" (lpMachineName As Long, lpDatabaseName As Long, ByVal dwDesiredAccess As SCM_ACCESS_TYPES) As Long
Private Declare Function EnumServicesStatus Lib "advapi32" Alias "EnumServicesStatusW" (ByVal hSCManager As Long, ByVal dwServiceType As SERVICE_TYPES, ByVal dwServiceState As SERVICE_STATE_MASK, ByRef lpServices As Any, ByVal cbBuffSize As Long, ByRef pcbBytesNeeded As Long, ByRef lpServicesReturned As Long, ByRef lpResumeHandle As Long) As Long
Private Declare Function GetServiceKeyName Lib "advapi32" Alias "GetServiceKeyNameW" (ByVal hSCManager As Long, lpDisplayName As Long, ByRef lpServiceName As Long, ByRef chBuffer As Long) As Long
Private Declare Function GetServiceDisplayName Lib "advapi32" Alias "GetServiceDisplayNameW" (ByVal hSCManager As Long, lpServiceName As Long, ByRef lpDisplayName As Long, ByRef chBuffer As Long) As Long
Private Declare Function OpenService Lib "advapi32" Alias "OpenServiceW" (ByVal hSCManager As Long, lpServiceName As Long, ByVal dwDesiredAccess As SERVICE_ACCESS_TYPES) As Long
Private Declare Function QueryServiceConfig Lib "advapi32" Alias "QueryServiceConfigW" (ByVal hService As Long, ByRef lpServiceConfig As Any, ByVal cbBuffSize As Long, ByRef pcbBytesNeeded As Long) As Long
Private Declare Function QueryServiceStatus Lib "advapi32" (ByVal hService As Long, ByRef lpServiceStatus As Any) As Long
Private Declare Function StartService Lib "advapi32" Alias "StartServiceW" (ByVal hService As Long, ByVal dwNumServiceArgs As Long, ByVal lpServiceArgVectors As Long) As Long
Private Declare Function ControlService Lib "advapi32" (ByVal hService As Long, ByVal dwControl As SERVICE_CONTROL_COMMANDS, ByRef lpServiceStatus As SERVICE_STATUS) As Long
Private Declare Function CloseServiceHandle Lib "advapi32" (ByVal hSCObject As Long) As Long

Private Declare Function lstrcpy Lib "kernel32" Alias "lstrcpyW" (lpDestination As Any, lpSource As Any) As Long

Public Enum ServiceTypes
  SvcTypeNone = SERVICE_TYPES.SERVICE_TYPE_NONE
  SvcTypeKernelDriver = SERVICE_TYPES.SERVICE_KERNEL_DRIVER
  SvcTypeFileSystemDriver = SERVICE_TYPES.SERVICE_FILE_SYSTEM_DRIVER
  SvcTypeAdapter = SERVICE_TYPES.SERVICE_ADAPTER
  SvcTypeRecognizerDriver = SERVICE_TYPES.SERVICE_RECOGNIZER_DRIVER
  SvcTypeServiceDriver = SERVICE_TYPES.SERVICE_DRIVER
  SvcTypeWin32OwnProcess = SERVICE_TYPES.SERVICE_WIN32_OWN_PROCESS
  SvcTypeWin32ShareProcess = SERVICE_TYPES.SERVICE_WIN32_SHARE_PROCESS
  SvcTypeWin32 = SERVICE_TYPES.SERVICE_WIN32
  SvcTypeInteractiveProcess = SERVICE_TYPES.SERVICE_INTERACTIVE_PROCESS
  SvcTypeAll = SERVICE_TYPES.SERVICE_TYPE_ALL
End Enum

Public Enum ServiceStates
  SvcStateInvalid = -1
  SvcStateNone = SERVICE_STATES.SERVICE_STATE_NONE
  SvcStateStopped = SERVICE_STATES.SERVICE_STOPPED
  SvcStateStartPending = SERVICE_STATES.SERVICE_START_PENDING
  SvcStateStopPending = SERVICE_STATES.SERVICE_STOP_PENDING
  SvcStateRunning = SERVICE_STATES.SERVICE_RUNNING
  SvcStateContinuePending = SERVICE_STATES.SERVICE_CONTINUE_PENDING
  SvcStatePausePending = SERVICE_STATES.SERVICE_PAUSE_PENDING
  SvcStatePaused = SERVICE_STATES.SERVICE_PAUSED
End Enum

Public Enum ServiceCmdAcceptMask
  SvcAcceptNone = SERVICE_CONTROLS_ACCEPTED.SERVICE_ACCEPT_NONE
  SvcAcceptStop = SERVICE_CONTROLS_ACCEPTED.SERVICE_ACCEPT_STOP
  SvcAcceptPauseContinue = SERVICE_CONTROLS_ACCEPTED.SERVICE_ACCEPT_PAUSE_CONTINUE
  SvcAcceptShutdown = SERVICE_CONTROLS_ACCEPTED.SERVICE_ACCEPT_SHUTDOWN
  SvcAcceptParamChange = SERVICE_CONTROLS_ACCEPTED.SERVICE_ACCEPT_PARAMCHANGE
  SvcAcceptAll = SERVICE_CONTROLS_ACCEPTED.SERVICE_ACCEPT_ALL
End Enum

Public Enum ServiceStartTypes
  SvcStartBoot = SERVICE_START_TYPES.SERVICE_BOOT_START
  SvcStartSystem = SERVICE_START_TYPES.SERVICE_SYSTEM_START
  SvcStartAuto = SERVICE_START_TYPES.SERVICE_AUTO_START
  SvcStartManual = SERVICE_START_TYPES.SERVICE_DEMAND_START
  SvcStartDisabled = SERVICE_START_TYPES.SERVICE_DISABLED
End Enum

Public Enum ServiceErrorControls
  SvcErrorControlIgnore = SERVICE_ERROR_CONTROL_TYPES.SERVICE_ERROR_IGNORE
  SvcErrorControlNormal = SERVICE_ERROR_CONTROL_TYPES.SERVICE_ERROR_NORMAL
  SvcErrorControlSevere = SERVICE_ERROR_CONTROL_TYPES.SERVICE_ERROR_SEVERE
  SvcErrorControlCritical = SERVICE_ERROR_CONTROL_TYPES.SERVICE_ERROR_CRITICAL
End Enum

Public Type ServiceInfoType
  ServiceName As String
  DisplayName As String
  CurrentState As ServiceStates
  StateAccepted As ServiceCmdAcceptMask
  WaitTime As Long
End Type

Public Type ServiceStatusType
  ServiceType As ServiceTypes
  CurrentState As ServiceStates
  ControlsAccepted As ServiceCmdAcceptMask
  Win32ExitCode As Long
  ServiceSpecificExitCode As Long
  CheckPoint As Long
  WaitHint As Long
End Type

Public Type ServiceConfigType
  ServiceType As ServiceTypes
  StartType As ServiceStartTypes
  ErrorControl As ServiceErrorControls
  BinaryPathName As String
  lpLoadOrderGroup As String
  TagID As Long
  Dependencies() As String
  ServiceStartName As String
  DisplayName As String
End Type

Sub TEST()
Dim Q As ServiceConfigType, I As Long
Call SVC_QueryServiceConfig("mssearch", Q)
Debug.Print Q.BinaryPathName
For I = 1 To UBound(Q.Dependencies)
  Debug.Print "  -> " & Q.Dependencies(I) & " (" & SVC_GetDisplayName(Q.Dependencies(I)) & ")"
Next I
End Sub

Private Sub TimerProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal idEvent As Long, ByVal dwTime As Long)
'
End Sub

Private Function StartTimer(ByVal Interval As Long) As Boolean
If TimerHandle <> 0& Then StopTimer
TimerHandle = SetTimer(ByVal 0&, ByVal 0&, Interval, AddressOf TimerProc)
StartTimer = (TimerHandle <> 0&)
End Function

Private Function StopTimer() As Boolean
Dim ret As Long
If TimerHandle = 0& Then Exit Function
ret = KillTimer(ByVal 0&, TimerHandle)
If ret <> 0& Then TimerHandle = 0&
StopTimer = (ret <> 0&)
End Function

Private Function ErrorMessage(ByVal ErrorCode As WINAPI_ERRORS) As String
Const MaxLen As Long = 1024
Dim msg As String, ret As Long
msg = String$(MaxLen, vbNullChar)
ret = ErrorFormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, ByVal 0&, ErrorCode, ByVal 0&, ByVal StrPtr(msg), MaxLen, ByVal 0&)
ErrorMessage = Left$(msg, ret)
End Function

Private Function GetNullTerminatedString(ByRef Pointer As Long, Optional ByVal MaxLength As Long = 1024&) As String
Dim buff As String, ret As Long
buff = String$(MaxLength, vbNullChar)
ret = lstrcpy(ByVal StrPtr(buff), ByVal Pointer)
If ret = 0 Then Exit Function
ret = InStr(buff, vbNullChar)
If ret = 0 Then
  GetNullTerminatedString = buff
Else
  GetNullTerminatedString = Left$(buff, ret - 1)
End If
End Function

Private Function GetNullTerminatedArray(ByRef Pointer As Long, Optional ByVal MaxLength As Long = 1024&) As String()
Dim B() As Byte, res() As String, S As String, P As Long, NullCount As Long
ReDim res(0)
P = Pointer
Do
  S = GetNullTerminatedString(P, MaxLength)
  If Len(S) = 0 Then Exit Do
  P = P + LenB(S) + 2
  ReDim Preserve res(0 To UBound(res) + 1)
  res(UBound(res)) = S
Loop
GetNullTerminatedArray = res
End Function

Private Sub StripNullTerminatedString(ByRef Value As String)
Dim I As Long
I = InStr(Value, vbNullChar)
If I = 0 Then
  Value = Value
Else
  Value = Left$(Value, I - 1)
End If
End Sub

Private Sub ProgressProc(ByVal Progress As Single)
If SVC_ProgressBar Is Nothing Then Exit Sub
If SVC_ProgressFrom < 0 Or SVC_ProgressTo < 0 Then Exit Sub
DrawProgressBar SVC_ProgressBar, SVC_ProgressFrom + (SVC_ProgressTo - SVC_ProgressFrom) * Progress / 100
End Sub

Public Function SVC_ListServices(ByRef Services() As ServiceInfoType) As Boolean
SVC_ErrorCode = 0&
SVC_ErrorMessage = vbNullString
SVC_ErrorDetails = vbNullString
Dim ret As Long, hSCManager As Long, BuffSize As Long, SvcCount As Long, SvcPtr As Long
Dim lpEnumServiceStatus() As ENUM_SERVICE_STATUS, N As Long, C As Long
hSCManager = OpenSCManager(ByVal 0&, ByVal 0&, SC_MANAGER_ENUMERATE_SERVICE)
If hSCManager = 0 Then
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "   ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  Exit Function
End If
ret = EnumServicesStatus(hSCManager, SERVICE_WIN32, SERVICE_STATE_ALL, ByVal 0&, ByVal 0&, BuffSize, SvcCount, ByVal 0&)
If ret = 0 Then
  If Err.LastDllError <> WINAPI_ERRORS.ERROR_MORE_DATA Then
    SVC_ErrorCode = Err.LastDllError
    SVC_ErrorMessage = "   ."
    SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
    CloseServiceHandle hSCManager
    Exit Function
  End If
End If
N = BuffSize / Len(lpEnumServiceStatus(0)) + 1
ReDim lpEnumServiceStatus(N - 1)
C = N * Len(lpEnumServiceStatus(0))
SvcPtr = 0
ret = EnumServicesStatus(hSCManager, SERVICE_WIN32, SERVICE_STATE_ALL, lpEnumServiceStatus(0), C, BuffSize, SvcCount, SvcPtr)
If ret = 0 Then
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "   ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  CloseServiceHandle hSCManager
  Exit Function
End If
ReDim Services(0 To SvcCount)
For C = 0 To SvcCount - 1
  With Services(C + 1)
    .ServiceName = GetNullTerminatedString(lpEnumServiceStatus(C).lpServiceName)
    .DisplayName = GetNullTerminatedString(lpEnumServiceStatus(C).lpDisplayName)
    .CurrentState = lpEnumServiceStatus(C).ServiceStatus.dwCurrentState
    .StateAccepted = lpEnumServiceStatus(C).ServiceStatus.dwControlsAccepted
    .WaitTime = lpEnumServiceStatus(C).ServiceStatus.dwWaitHint
  End With
Next C
CloseServiceHandle hSCManager
Erase lpEnumServiceStatus
SVC_ListServices = True
End Function

Public Function SVC_Exists(Optional ByVal ServiceName As String, Optional ByVal DisplayName As String) As Boolean
SVC_ErrorCode = 0&
SVC_ErrorMessage = vbNullString
SVC_ErrorDetails = vbNullString
Dim ret As Long, hSCManager As Long, S As String, L As Long
If Len(ServiceName) = 0 And Len(DisplayName) = 0 Then Exit Function
hSCManager = OpenSCManager(ByVal 0&, ByVal 0&, SC_MANAGER_ENUMERATE_SERVICE)
If hSCManager = 0 Then
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "   ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  Exit Function
End If
S = String$(256, vbNullChar)
L = Len(S)
If Len(ServiceName) > 0 Then
  ret = GetServiceDisplayName(hSCManager, ByVal StrPtr(ServiceName), ByVal StrPtr(S), L)
  If ret <> 0& Then
    S = Left$(S, L)
    SVC_Exists = True
  End If
Else
  ret = GetServiceKeyName(hSCManager, ByVal StrPtr(DisplayName), ByVal StrPtr(S), L)
  If ret <> 0& Then
    S = Left$(S, L)
    SVC_Exists = True
  End If
End If
CloseServiceHandle hSCManager
End Function

Public Function SVC_GetDisplayName(ByVal ServiceName As String) As String
SVC_ErrorCode = 0&
SVC_ErrorMessage = vbNullString
SVC_ErrorDetails = vbNullString
Dim ret As Long, hSCManager As Long, S As String, L As Long
If Len(ServiceName) = 0 Then Exit Function
hSCManager = OpenSCManager(ByVal 0&, ByVal 0&, SC_MANAGER_ENUMERATE_SERVICE)
If hSCManager = 0 Then
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "   ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  Exit Function
End If
S = String$(256, vbNullChar)
L = Len(S)
ret = GetServiceDisplayName(hSCManager, ByVal StrPtr(ServiceName), ByVal StrPtr(S), L)
If ret <> 0& Then
  S = Left$(S, L)
  SVC_GetDisplayName = S
End If
CloseServiceHandle hSCManager
End Function

Public Function SVC_GetServiceName(ByVal DisplayName As String) As String
SVC_ErrorCode = 0&
SVC_ErrorMessage = vbNullString
SVC_ErrorDetails = vbNullString
Dim ret As Long, hSCManager As Long, S As String, L As Long
If Len(DisplayName) = 0 Then Exit Function
hSCManager = OpenSCManager(ByVal 0&, ByVal 0&, SC_MANAGER_ENUMERATE_SERVICE)
If hSCManager = 0 Then
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "   ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  Exit Function
End If
S = String$(256, vbNullChar)
L = Len(S)
ret = GetServiceKeyName(hSCManager, ByVal StrPtr(DisplayName), ByVal StrPtr(S), L)
If ret <> 0& Then
  S = Left$(S, L)
  SVC_GetServiceName = S
End If
CloseServiceHandle hSCManager
End Function

Public Function SVC_QueryServiceStatus(ByVal ServiceName As String, ByRef Status As ServiceStatusType) As Boolean
SVC_ErrorCode = 0&
SVC_ErrorMessage = vbNullString
SVC_ErrorDetails = vbNullString
Dim ret As Long, hSCManager As Long, hService As Long, P As SERVICE_STATUS
If Len(ServiceName) = 0 Then Exit Function
hSCManager = OpenSCManager(ByVal 0&, ByVal 0&, SC_MANAGER_ENUMERATE_SERVICE)
If hSCManager = 0 Then
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "   ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  Exit Function
End If
hService = OpenService(hSCManager, ByVal StrPtr(ServiceName), SERVICE_QUERY_STATUS)
If hService = 0 Then
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "  ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  CloseServiceHandle hSCManager
  Exit Function
End If
ret = QueryServiceStatus(hService, P)
If ret = 0 Then
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "  ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  CloseServiceHandle hService
  CloseServiceHandle hSCManager
  Exit Function
End If
With Status
  .ServiceType = P.dwServiceType
  .CurrentState = P.dwCurrentState
  .ControlsAccepted = P.dwControlsAccepted
  .Win32ExitCode = P.dwWin32ExitCode
  .ServiceSpecificExitCode = P.dwServiceSpecificExitCode
  .CheckPoint = P.dwCheckPoint
  .WaitHint = P.dwWaitHint
End With
CloseServiceHandle hService
CloseServiceHandle hSCManager
SVC_QueryServiceStatus = True
End Function

Public Function SVC_QueryServiceConfig(ByVal ServiceName As String, ByRef Config As ServiceConfigType) As Boolean
SVC_ErrorCode = 0&
SVC_ErrorMessage = vbNullString
SVC_ErrorDetails = vbNullString
Dim ret As Long, hSCManager As Long, hService As Long, P() As QUERY_SERVICE_CONFIG, B As Long, L As Long, N As Long
If Len(ServiceName) = 0 Then Exit Function
hSCManager = OpenSCManager(ByVal 0&, ByVal 0&, SC_MANAGER_ENUMERATE_SERVICE)
If hSCManager = 0 Then
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "   ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  Exit Function
End If
hService = OpenService(hSCManager, ByVal StrPtr(ServiceName), SERVICE_QUERY_CONFIG)
If hService = 0 Then
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "  ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  CloseServiceHandle hSCManager
  Exit Function
End If
ret = QueryServiceConfig(hService, ByVal 0&, 0&, B)
If ret = 0 Then
  If Err.LastDllError <> WINAPI_ERRORS.ERROR_INSUFFICIENT_BUFFER Then
    SVC_ErrorCode = Err.LastDllError
    SVC_ErrorMessage = "  ."
    SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
    CloseServiceHandle hService
    CloseServiceHandle hSCManager
    Exit Function
  End If
End If
N = B / Len(P(0)) + 1
ReDim P(N - 1)
L = B
ret = QueryServiceConfig(hService, P(0), L, B)
If ret = 0 Then
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "  ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  CloseServiceHandle hService
  CloseServiceHandle hSCManager
  Exit Function
End If
With Config
  .ServiceType = P(0).dwServiceType
  .StartType = P(0).dwStartType
  .ErrorControl = P(0).dwErrorControl
  .BinaryPathName = GetNullTerminatedString(P(0).lpBinaryPathName, P(0).lpLoadOrderGroup - P(0).lpBinaryPathName)
  .lpLoadOrderGroup = GetNullTerminatedString(P(0).lpLoadOrderGroup, P(0).lpDependencies - P(0).lpLoadOrderGroup - 4)
  .TagID = P(0).dwTagId
  .Dependencies() = GetNullTerminatedArray(P(0).lpDependencies, P(0).lpServiceStartName - P(0).lpDependencies)
  .ServiceStartName = GetNullTerminatedString(P(0).lpServiceStartName, P(0).lpDisplayName - P(0).lpServiceStartName)
  .DisplayName = GetNullTerminatedString(P(0).lpDisplayName, L - (P(0).lpDisplayName - VarPtr(P(0))) + 1)
End With
CloseServiceHandle hService
CloseServiceHandle hSCManager
Erase P
SVC_QueryServiceConfig = True
End Function

Public Function SVC_State(ByVal ServiceName As String) As ServiceStates
SVC_ErrorCode = 0&
SVC_ErrorMessage = vbNullString
SVC_ErrorDetails = vbNullString
SVC_State = SvcStateInvalid
Dim ret As Long, hSCManager As Long, hService As Long, P As SERVICE_STATUS
If Len(ServiceName) = 0 Then Exit Function
hSCManager = OpenSCManager(ByVal 0&, ByVal 0&, SC_MANAGER_ENUMERATE_SERVICE)
If hSCManager = 0 Then
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "   ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  Exit Function
End If
hService = OpenService(hSCManager, ByVal StrPtr(ServiceName), SERVICE_QUERY_STATUS)
If hService = 0 Then
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "  ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  CloseServiceHandle hSCManager
  Exit Function
End If
ret = QueryServiceStatus(hService, P)
If ret = 0 Then
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "  ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  CloseServiceHandle hService
  CloseServiceHandle hSCManager
  SVC_State = SvcStateNone
  Exit Function
End If
SVC_State = P.dwCurrentState
CloseServiceHandle hService
CloseServiceHandle hSCManager
End Function

Public Function SVC_Start(ByVal ServiceName As String, Optional ByVal Timeout As Long) As Boolean
If SVC_CancelServiceOperation Then Exit Function
SVC_ServiceControlFail = False
SVC_ErrorCode = 0&
SVC_ErrorMessage = vbNullString
SVC_ErrorDetails = vbNullString
If SVC_State(ServiceName) = SvcStateRunning Then
  SVC_Start = True
  Exit Function
End If
Dim ret As Long, hSCManager As Long, hService As Long, S As SERVICE_STATUS
Dim TmrStart As Long, TmrInterval As Long, TmrElapse As Long, TmrTagQuery As Long, TmrTagProgress As Long
If Len(ServiceName) = 0 Then Exit Function
hSCManager = OpenSCManager(ByVal 0&, ByVal 0&, SC_MANAGER_ENUMERATE_SERVICE)
If hSCManager = 0 Then
  SVC_ServiceControlFail = True
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "   ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  Exit Function
End If
ProgressProc 0
hService = OpenService(hSCManager, ByVal StrPtr(ServiceName), SERVICE_QUERY_STATUS Or SERVICE_START)
If hService = 0 Then
  SVC_ServiceControlFail = True
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "  ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  CloseServiceHandle hSCManager
  Exit Function
End If
ret = QueryServiceStatus(hService, S)
If ret = 0 Then
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "  ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  CloseServiceHandle hService
  CloseServiceHandle hSCManager
  Exit Function
End If
If Timeout = 0 Then Timeout = S.dwWaitHint
If Timeout = 0 Then Timeout = 2000
TmrStart = GetTickCount()
TmrInterval = Timeout / 10
If TmrInterval < 1000 Then TmrInterval = 1000
If TmrInterval > 10000 Then TmrInterval = 10000
ret = StartService(hService, ByVal 0&, ByVal 0&)
If ret = 0 Then
  SVC_ServiceControlFail = True
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "  ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  CloseServiceHandle hService
  CloseServiceHandle hSCManager
  Exit Function
End If
Do
  TmrElapse = GetTickCount() - TmrStart
  If TmrElapse > Timeout Then
    SVC_ServiceControlFail = True
    SVC_ErrorCode = -1
    SVC_ErrorMessage = "   ,   ."
    SVC_ErrorDetails = vbNullString
    CloseServiceHandle hService
    CloseServiceHandle hSCManager
    ProgressProc 100
    Exit Function
  End If
  If (TmrElapse - TmrTagProgress) >= 100 Then
    TmrTagProgress = TmrElapse
    ProgressProc 100 * TmrElapse / Timeout
  End If
  DoEvents
  If SVC_CancelServiceOperation Then
    SVC_ErrorCode = -1
    SVC_ErrorMessage = "  ."
    SVC_ErrorDetails = vbNullString
    CloseServiceHandle hService
    CloseServiceHandle hSCManager
    ProgressProc 100
    Exit Function
  End If
  If (TmrElapse - TmrTagQuery) >= TmrInterval Then
    TmrTagQuery = TmrElapse
    ret = QueryServiceStatus(hService, S)
    If S.dwCurrentState = SERVICE_RUNNING Then Exit Do
  End If
Loop
ProgressProc 100
CloseServiceHandle hService
CloseServiceHandle hSCManager
SVC_Start = True
End Function

Public Function SVC_Stop(ByVal ServiceName As String, Optional ByVal Timeout As Long) As Boolean
If SVC_CancelServiceOperation Then Exit Function
SVC_ServiceControlFail = False
SVC_ErrorCode = 0&
SVC_ErrorMessage = vbNullString
SVC_ErrorDetails = vbNullString
If SVC_State(ServiceName) = SvcStateStopped Then
  SVC_Stop = True
  Exit Function
End If
Dim ret As Long, hSCManager As Long, hService As Long, S As SERVICE_STATUS
Dim TmrStart As Long, TmrInterval As Long, TmrElapse As Long, TmrTagQuery As Long, TmrTagProgress As Long
If Len(ServiceName) = 0 Then Exit Function
hSCManager = OpenSCManager(ByVal 0&, ByVal 0&, SC_MANAGER_ENUMERATE_SERVICE)
If hSCManager = 0 Then
  SVC_ServiceControlFail = True
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "   ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  Exit Function
End If
ProgressProc 0
hService = OpenService(hSCManager, ByVal StrPtr(ServiceName), SERVICE_QUERY_STATUS Or SERVICE_STOP)
If hService = 0 Then
  SVC_ServiceControlFail = True
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "  ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  CloseServiceHandle hSCManager
  Exit Function
End If
ret = QueryServiceStatus(hService, S)
If ret = 0 Then
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "  ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  CloseServiceHandle hService
  CloseServiceHandle hSCManager
  Exit Function
End If
If Timeout = 0 Then Timeout = S.dwWaitHint
If Timeout = 0 Then Timeout = 2000
TmrStart = GetTickCount()
TmrInterval = Timeout / 10
If TmrInterval < 1000 Then TmrInterval = 1000
If TmrInterval > 10000 Then TmrInterval = 10000
ret = ControlService(hService, SERVICE_CONTROL_STOP, S)
If ret = 0 Then
  SVC_ServiceControlFail = True
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "  ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  CloseServiceHandle hService
  CloseServiceHandle hSCManager
  Exit Function
End If
Do
  TmrElapse = GetTickCount() - TmrStart
  If TmrElapse > Timeout Then
    SVC_ServiceControlFail = True
    SVC_ErrorCode = -1
    SVC_ErrorMessage = "   ,   ."
    SVC_ErrorDetails = vbNullString
    CloseServiceHandle hService
    CloseServiceHandle hSCManager
    ProgressProc 100
    Exit Function
  End If
  If (TmrElapse - TmrTagProgress) >= 100 Then
    TmrTagProgress = TmrElapse
    ProgressProc 100 * TmrElapse / Timeout
  End If
  DoEvents
  If SVC_CancelServiceOperation Then
    SVC_ErrorCode = -1
    SVC_ErrorMessage = "  ."
    SVC_ErrorDetails = vbNullString
    CloseServiceHandle hService
    CloseServiceHandle hSCManager
    ProgressProc 100
    Exit Function
  End If
  If (TmrElapse - TmrTagQuery) >= TmrInterval Then
    TmrTagQuery = TmrElapse
    ret = QueryServiceStatus(hService, S)
    If S.dwCurrentState = SERVICE_STOPPED Then Exit Do
  End If
Loop
ProgressProc 100
CloseServiceHandle hService
CloseServiceHandle hSCManager
SVC_Stop = True
End Function

Public Function SVC_Pause(ByVal ServiceName As String, Optional ByVal Timeout As Long) As Boolean
If SVC_CancelServiceOperation Then Exit Function
SVC_ServiceControlFail = False
SVC_ErrorCode = 0&
SVC_ErrorMessage = vbNullString
SVC_ErrorDetails = vbNullString
If SVC_State(ServiceName) = SvcStatePausePending Then
  SVC_Pause = True
  Exit Function
End If
Dim ret As Long, hSCManager As Long, hService As Long, S As SERVICE_STATUS
Dim TmrStart As Long, TmrInterval As Long, TmrElapse As Long, TmrTagQuery As Long, TmrTagProgress As Long
If Len(ServiceName) = 0 Then Exit Function
hSCManager = OpenSCManager(ByVal 0&, ByVal 0&, SC_MANAGER_ENUMERATE_SERVICE)
If hSCManager = 0 Then
  SVC_ServiceControlFail = True
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "   ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  Exit Function
End If
ProgressProc 0
hService = OpenService(hSCManager, ByVal StrPtr(ServiceName), SERVICE_QUERY_STATUS Or SERVICE_PAUSE_CONTINUE)
If hService = 0 Then
  SVC_ServiceControlFail = True
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "  ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  CloseServiceHandle hSCManager
  Exit Function
End If
ret = QueryServiceStatus(hService, S)
If ret = 0 Then
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "  ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  CloseServiceHandle hService
  CloseServiceHandle hSCManager
  Exit Function
End If
If Timeout = 0 Then Timeout = S.dwWaitHint
If Timeout = 0 Then Timeout = 2000
TmrStart = GetTickCount()
TmrInterval = Timeout / 10
If TmrInterval < 1000 Then TmrInterval = 1000
If TmrInterval > 10000 Then TmrInterval = 10000
ret = ControlService(hService, SERVICE_CONTROL_PAUSE, S)
If ret = 0 Then
  SVC_ServiceControlFail = True
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "  ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  CloseServiceHandle hService
  CloseServiceHandle hSCManager
  Exit Function
End If
Do
  TmrElapse = GetTickCount() - TmrStart
  If TmrElapse > Timeout Then
    SVC_ServiceControlFail = True
    SVC_ErrorCode = -1
    SVC_ErrorMessage = "   ,   ."
    SVC_ErrorDetails = vbNullString
    CloseServiceHandle hService
    CloseServiceHandle hSCManager
    ProgressProc 100
    Exit Function
  End If
  If (TmrElapse - TmrTagProgress) >= 100 Then
    TmrTagProgress = TmrElapse
    ProgressProc 100 * TmrElapse / Timeout
  End If
  DoEvents
  If SVC_CancelServiceOperation Then
    SVC_ErrorCode = -1
    SVC_ErrorMessage = "  ."
    SVC_ErrorDetails = vbNullString
    CloseServiceHandle hService
    CloseServiceHandle hSCManager
    ProgressProc 100
    Exit Function
  End If
  If (TmrElapse - TmrTagQuery) >= TmrInterval Then
    TmrTagQuery = TmrElapse
    ret = QueryServiceStatus(hService, S)
    If S.dwCurrentState = SERVICE_PAUSED Then Exit Do
  End If
Loop
ProgressProc 100
CloseServiceHandle hService
CloseServiceHandle hSCManager
SVC_Pause = True
End Function

Public Function SVC_Continue(ByVal ServiceName As String, Optional ByVal Timeout As Long) As Boolean
If SVC_CancelServiceOperation Then Exit Function
SVC_ServiceControlFail = False
SVC_ErrorCode = 0&
SVC_ErrorMessage = vbNullString
SVC_ErrorDetails = vbNullString
If SVC_State(ServiceName) = SvcStatePausePending Then
  SVC_Continue = True
  Exit Function
End If
Dim ret As Long, hSCManager As Long, hService As Long, S As SERVICE_STATUS
Dim TmrStart As Long, TmrInterval As Long, TmrElapse As Long, TmrTagQuery As Long, TmrTagProgress As Long
If Len(ServiceName) = 0 Then Exit Function
hSCManager = OpenSCManager(ByVal 0&, ByVal 0&, SC_MANAGER_ENUMERATE_SERVICE)
If hSCManager = 0 Then
  SVC_ServiceControlFail = True
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "   ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  Exit Function
End If
ProgressProc 0
hService = OpenService(hSCManager, ByVal StrPtr(ServiceName), SERVICE_QUERY_STATUS Or SERVICE_PAUSE_CONTINUE)
If hService = 0 Then
  SVC_ServiceControlFail = True
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "  ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  CloseServiceHandle hSCManager
  Exit Function
End If
ret = QueryServiceStatus(hService, S)
If ret = 0 Then
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "  ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  CloseServiceHandle hService
  CloseServiceHandle hSCManager
  Exit Function
End If
If Timeout = 0 Then Timeout = S.dwWaitHint
If Timeout = 0 Then Timeout = 2000
TmrStart = GetTickCount()
TmrInterval = Timeout / 10
If TmrInterval < 1000 Then TmrInterval = 1000
If TmrInterval > 10000 Then TmrInterval = 10000
ret = ControlService(hService, SERVICE_CONTROL_CONTINUE, S)
If ret = 0 Then
  SVC_ServiceControlFail = True
  SVC_ErrorCode = Err.LastDllError
  SVC_ErrorMessage = "  ."
  SVC_ErrorDetails = ErrorMessage(SVC_ErrorCode)
  CloseServiceHandle hService
  CloseServiceHandle hSCManager
  Exit Function
End If
Do
  TmrElapse = GetTickCount() - TmrStart
  If TmrElapse > Timeout Then
    SVC_ServiceControlFail = True
    SVC_ErrorCode = -1
    SVC_ErrorMessage = "   ,   ."
    SVC_ErrorDetails = vbNullString
    CloseServiceHandle hService
    CloseServiceHandle hSCManager
    ProgressProc 100
    Exit Function
  End If
  If (TmrElapse - TmrTagProgress) >= 100 Then
    TmrTagProgress = TmrElapse
    ProgressProc 100 * TmrElapse / Timeout
  End If
  DoEvents
  If SVC_CancelServiceOperation Then
    SVC_ErrorCode = -1
    SVC_ErrorMessage = "  ."
    SVC_ErrorDetails = vbNullString
    CloseServiceHandle hService
    CloseServiceHandle hSCManager
    ProgressProc 100
    Exit Function
  End If
  If (TmrElapse - TmrTagQuery) >= TmrInterval Then
    TmrTagQuery = TmrElapse
    ret = QueryServiceStatus(hService, S)
    If S.dwCurrentState = SERVICE_RUNNING Then Exit Do
  End If
Loop
ProgressProc 100
CloseServiceHandle hService
CloseServiceHandle hSCManager
SVC_Continue = True
End Function
